package io.xjar;

import io.xjar.jar.XJarRegexEntryFilter;
import io.xjar.jar.XJarAntEntryFilter;
import io.xjar.filter.XNotEntryFilter;
import io.xjar.filter.XAnyEntryFilter;
import java.util.Collection;
import io.xjar.filter.XAllEntryFilter;
import org.apache.commons.compress.archivers.jar.JarArchiveEntry;
import io.xjar.filter.XMixEntryFilter;

public abstract class XFilters
{
    public static XMixEntryFilter<JarArchiveEntry> all() {
        return (XMixEntryFilter<JarArchiveEntry>)new XAllEntryFilter();
    }
    
    public static XMixEntryFilter<JarArchiveEntry> all(final Collection<? extends XEntryFilter<? extends JarArchiveEntry>> filters) {
        return (XMixEntryFilter<JarArchiveEntry>)new XAllEntryFilter((Collection)filters);
    }
    
    public static XMixEntryFilter<JarArchiveEntry> and() {
        return all();
    }
    
    public static XMixEntryFilter<JarArchiveEntry> and(final Collection<? extends XEntryFilter<? extends JarArchiveEntry>> filters) {
        return all(filters);
    }
    
    public static XMixEntryFilter<JarArchiveEntry> any() {
        return (XMixEntryFilter<JarArchiveEntry>)new XAnyEntryFilter();
    }
    
    public static XMixEntryFilter<JarArchiveEntry> any(final Collection<? extends XEntryFilter<? extends JarArchiveEntry>> filters) {
        return (XMixEntryFilter<JarArchiveEntry>)new XAnyEntryFilter((Collection)filters);
    }
    
    public static XMixEntryFilter<JarArchiveEntry> or() {
        return any();
    }
    
    public static XMixEntryFilter<JarArchiveEntry> or(final Collection<? extends XEntryFilter<? extends JarArchiveEntry>> filters) {
        return any(filters);
    }
    
    public static XNotEntryFilter<JarArchiveEntry> not(final XEntryFilter<JarArchiveEntry> filter) {
        return (XNotEntryFilter<JarArchiveEntry>)new XNotEntryFilter((XEntryFilter)filter);
    }
    
    public static XJarAntEntryFilter ant(final String ant) {
        return new XJarAntEntryFilter(ant);
    }
    
    public static XJarRegexEntryFilter regex(final String regex) {
        return new XJarRegexEntryFilter(regex);
    }
}
